
#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <string.h>
#include <xc.h>
#include <sys/attribs.h>
#include <sys/kmem.h>
#include "FT8xx.h"
#include "Library.h"
#include "function_prototypes.h"
#include "nextion_var.h"
#include "global.h"

volatile int CN_count=0;
volatile int oldRPM = 0;
volatile int desiredRPM = 6000;
volatile int newRPM = 0;
volatile int error;
unsigned int integral = 0;
float Kp =.12, Ki = .16, Kd =.01; //PID settings
int PID;
int derivative;
int servoMin = 5300; //idle
int servoMax = 3320; //full throttle

void __ISR(16, IPL6AUTO) Timer4Hand(void) //computes rpm each 1/5 of a second
{
IFS0bits.T4IF = 0; // clear flag
oldRPM = newRPM;
newRPM = 5*CN_count*10;  // Square wave frequency = 5*count. RPM = 20* sq Wave frequency
error = desiredRPM - newRPM;
if(integral > 60000){
    integral = 60000;
}
else{
    if(newRPM>1000){
     integral = (integral + error/5); //integral in kRPM*s
    }
    else
        integral = 0;
}
derivative = (newRPM - oldRPM)*5; //derivative in RPM/s
//OC1RS = 4000;
CN_count=0;
}

void __ISR(7, IPL7SOFT) INT1_ISR(void){
    int val = PORTD;
    CN_count++;
    IFS0bits.INT1IF= 0;
}

void init_PID_RPM(){
    initOC();
    integral = 0;
    //initialize timer 4
    initTimer4();
    initINT1();
    T4CONbits.ON= 1; // turn on timer
}

void updateOC(){
    OC1RS=PID;
    float errorF= (float) error, integralF = (float) integral, derivativeF = (float) derivative;
    PID = servoMin - errorF*Kp - integralF*Ki + derivativeF*Kd - .5;

    if(PID > servoMin){
        PID = servoMin;
    }else if(PID < servoMax){
       PID = servoMax;
    }
}

//void killTime(void){
  //  int x=0;
    // Wait for 60 us
    //while(x<9000){
      //  x=x+1;
    //}
//}