#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <string.h>
#include <xc.h>
#include <sys/attribs.h>
#include <sys/kmem.h>
#include "FT8xx.h"
#include "Library.h"
#include "function_prototypes.h"
#include "SPI.h"



// Initialize isolated SPI
void initISO_SPI2(void){
   CS_ISOB = 1;  
   CS_ISOB_test = CS_ISOB;//Set CS high (idle state)

    CNPUEbits.CNPUE9 = 1;
    CNPUEbits.CNPUE10 = 1;

    
    AD1PCFG = 0xFFFF;           // set all pins to digital
    DDPCON = 0x0000;            // disable JTAG
    IEC1bits.SPI2EIE = 0;       // SPI interrupts disabled
    IEC1bits.SPI2RXIE = 0;
    IEC1bits.SPI2TXIE = 0;
    SPI2CONbits.ON = 0;         // Turn off SPI module
     
    SPI2BUF = 0;                // Clear the receive buffer
     
    SPI2BRG = 19;                // FSCK = 1MHz
     //SPI4BRG = 0;                // FSCK = 20MHz (once we get it working)
     
    SPI2STATbits.SPIROV = 0;    // Clear overflow flag
     
     
    /* SPI1CON settings */
    SPI2CONbits.FRMEN = 0;      // Framed SPI support is disabled
    SPI2CONbits.SIDL = 0;       // Continue operation in IDLE mode
    SPI2CONbits.DISSDO = 0;     // SDO1 pin is controlled by the module

    // WAS CKP = 1, CKE =0 with translator board
    SPI2CONbits.CKP = 1;        // Idle state for clock is high, active state is low, on rising edge
    SPI2CONbits.CKE = 0; //changed it from 0       // Output data changes on transition from idle to active
    SPI2CONbits.SSEN = 0;       // Not in slave mode
    SPI2CONbits.MSTEN = 1;      // Master mode
    SPI2CONbits.SMP = 0;        // Input data sampled at the middle of data output time
     
    SPI2CONbits.ON = 1;         // Turn module on
    
sensorNum = 0xFF;
overvoltNum = 0xFF;
AMSboard = "No Error";
sensorVal=0;
sumVoltages=0;
}




// kill time functions
void kill1Time(){
    int x=0;
    while(x<100){
        x++;
    }
}

void suchTime(){
    kill1Time();
    kill1Time();
    kill1Time();
    kill1Time();
    kill1Time();
    kill1Time();
    kill1Time();
    kill1Time();
    kill1Time();
    kill1Time();
    kill1Time();
    kill1Time();
    kill1Time();
    kill1Time();
    kill1Time();
    kill1Time();
    kill1Time();
    kill1Time();
    kill1Time();
    kill1Time();
    kill1Time();
    kill1Time();
    kill1Time();
    
}

void errorMessageTranslator(unsigned short x){
    unsigned short type = 0b11000000;
    sensorNum = (0xFF & x);
    overvoltNum = (0xFF & x);
    AMSboard = " ";
  
    type = (type & x);
    
// Error type is Temperature is out of range
    
    if(type == 0x80){
        sensorNum = (sensorNum & 0b00111111);
        if(sensorNum < 8){
            AMSboard = "Board A - Temperature Error";
            
        }else if(sensorNum < 16){
            AMSboard = "Board B - Temperature Error";
            sensorNum = sensorNum - 8;
        }else if(sensorNum < 24){
            AMSboard = "Board C - Temperature Error";
            sensorNum = sensorNum - 16;
        }else{
            AMSboard = "Board D - Temperature Error";
            sensorNum = sensorNum - 24;
        }
        sensorVal = sensorNum;
    }else if(type == 0xC0){  // Error type is Over voltage is triggered
        overvoltNum = (overvoltNum & 0b00111111);
        if(overvoltNum < 15){
            AMSboard = "Board A - OV Error";
        }else if(overvoltNum < 30){
            AMSboard = "Board B - OV Error";
            overvoltNum = overvoltNum - 15;
        }else if(overvoltNum < 45){
            AMSboard = "Board C - OV Error";
            overvoltNum = overvoltNum - 30;
        }else{
            AMSboard = "Board D - OV Error";
            overvoltNum = overvoltNum - 45;
        }
        sensorVal = overvoltNum;
    }else{
        AMSboard = "No Error";
        sensorVal=0;
    }
}

// Read capaitor info from AMS board
void getInfo(){
    suchTime();
    unsigned short temps;
    CS_ISOB=0;
    CS_ISOB_test = CS_ISOB;
    temps = WriteReadSPI(0xFA); // Start :: Next variable is high byte of Sum of cells
    CS_ISOB=1;
    CS_ISOB_test = CS_ISOB;
    kill1Time();
    CS_ISOB=0;
    CS_ISOB_test = CS_ISOB;
    sumVoltages = (WriteReadSPI(0xFB));// << 8); // Writes to AMS Board to Ask for next variable :: low byte of Summ of cells
    CS_ISOB=1;
    CS_ISOB_test = CS_ISOB;
    kill1Time();
    CS_ISOB=0;
    CS_ISOB_test = CS_ISOB;
    sumVoltages =  WriteReadSPI(0xFC);//(sumVoltages & 0xFF00) +  WriteReadSPI(0xFC); // Reads from AMS board
    CS_ISOB=1;
    CS_ISOB_test = CS_ISOB;
    kill1Time();
    CS_ISOB=0;
    CS_ISOB_test = CS_ISOB;
    temps = WriteReadSPI(0xFD); // This is the error message
    CS_ISOB=1;
    CS_ISOB_test = CS_ISOB;
    kill1Time();
    errorMessageTranslator(temps);
    CS_ISOB=0;
    CS_ISOB_test = CS_ISOB;
    tempFinal = WriteReadSPI(0xFE);// + 200; // This is the error message
    CS_ISOB=1;
    CS_ISOB_test = CS_ISOB;
    // Implement after thermistor are installed //
    
//    CS_ISOB=0;
//    temp = WriteReadSPI(0xFE); // This is the error message
//    CS_ISOB=1;
}

short WriteReadSPI(unsigned short i){
    SPI2BUF = i;                    // Write to buffer for transmission
    while (!SPI2STATbits.SPIRBF);   // Wait for transfer to be completed
    return SPI2BUF;                 // Return the received value
}

